#include <stdio.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>

#include "lista-articoli.pb-c.h"
#define DIM 4096

int main(int argc, char** argv){
	
	struct addrinfo hints;
	struct addrinfo *res,*ptr;
	char *host_remoto;
	char *servizio_remoto;
	int err, sd, nread, i=1, len, username_tmp;
	
	char buf[DIM], email[DIM];
	Revisore revisore = REVISORE__INIT;
	void *req_buf;
	
	/* Controllo argomenti */
	if (argc < 3){
		printf("Uso: lista_articoli <server> <porta>\n");
		exit(1);
	}
	
	/* Lettura dati dall'utente */
	printf("Inserisci username:\n");
	scanf("%d", &username_tmp);
	if( username_tmp == -1 ){
		revisore.has_username = 0;
	}
	else{
		revisore.has_username = 1;
		revisore.username = username_tmp;
	}
	
	printf("Inserisci email:\n");
	scanf("%s", email);
	revisore.email = email;
		
	printf("Inserisci password:\n");
	scanf("%d", &(revisore.password) );
			
	/* Costruzione dell'indirizzo */
	memset(&hints, 0, sizeof(hints));
	hints.ai_family   = AF_INET;
	hints.ai_socktype = SOCK_STREAM;

	/* Risoluzione dell'host */
	host_remoto = argv[1];
	servizio_remoto = argv[2];
	
	if ((err = getaddrinfo(host_remoto, servizio_remoto, &hints, &res)) != 0) {
		fprintf(stderr, "Errore risoluzione nome: %s\n", gai_strerror(err));
		exit(2);
	}
	
	/* Connessione con fallback */
	for(ptr = res; ptr != NULL; ptr = ptr->ai_next){
		/*se socket fallisce salto direttamente alla prossima iterazione*/
		if ((sd = socket(ptr->ai_family, ptr->ai_socktype, ptr->ai_protocol)) < 0){
			fprintf(stderr,"creazione socket fallita\n");
			continue;
		}
		/*se connect funziona esco dal ciclo*/
		if (connect(sd, ptr->ai_addr, ptr->ai_addrlen) == 0){
			printf("connect riuscita al tentativo %d\n",i);
			break;
		}
		i++;
		close(sd);
	}

	/* Verifica sul risultato restituito da getaddrinfo */
	if (ptr == NULL) {
		fprintf(stderr, "Errore risoluzione nome: nessun indirizzo corrispondente trovato\n");
		exit(3);
	}
	
	// Liberiamo la memoria allocata da getaddrinfo()
	freeaddrinfo(res);
	
	/* Scambio dati col server */
	
	// Serializzazione Protobuf
	len = revisore__get_packed_size(&revisore);
	req_buf = malloc(len);
	revisore__pack(&revisore,req_buf);

	// Mando il messaggio Protobuf
	if (write(sd, req_buf, len) < 0) {
		perror("write struct");
		exit(5);
	}
	
	// Importante!
	free(req_buf);
	
	
	/* Ricezione risultato */

	/* È consigliabile effettuare il flushing del buffer di printf
	 * prima di iniziare a scrivere sullo standard output con write */
	fflush(stdout);
	memset(buf, 0, sizeof(buf));
	while ((nread = read(sd, buf, DIM)) > 0) {
		 if (write(1, buf, nread) < 0) {
			 perror("write su stdout");
			 exit(9);
		 }
	}
		
	/* Controllo errori di lettura */
  	if (nread < 0) {
		perror("read del risultato");
		exit(10);
	}
	
	return 0;
}
